﻿Type=Class
Version=1.45
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private PostForm As Form
	Private nposttxt As TextField
	Private iptxt As TextField
	Private nameposttxt As TextField
	Private tablearcpost As TableView
	Private SQL1 As SQL
	Private msg As Msgboxes
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	PostForm.Initialize("", Main.MainForm.Width, Main.MainForm.Height)
	PostForm.Resizable = False
	PostForm.RootPane.LoadLayout("SetPost")
	tablearcpost.Style = "-fx-font-size: 12;" & "-fx-font-weight: bold;" & "-fx-background-color: white;"
	InitTable
	DBUtils.ExecuteTableView(SQL1, "SELECT * FROM Postazioni", Null, 0, tablearcpost)
	SetColWidth(1)
	PostForm.SetOwner(Main.MainForm)
	PostForm.Show
	nposttxt.TooltipText = "Numero postazione"
	iptxt.TooltipText = "IP postazione"
	nameposttxt.TooltipText = "Nome postazione"
	nposttxt.RequestFocus
End Sub
Sub nposttxt_Action
	If nposttxt.Text <> "" Then iptxt.RequestFocus
End Sub
Sub nposttxt_TextChanged (Old As String, New As String)
Dim sb As StringBuilder
Dim txt As TextField
   txt = Sender	
   sb.Initialize
   For i = 0 To New.Length - 1
     If "0123456789".IndexOf(New.CharAt(i)) > -1 Then
       sb.Append(New.CharAt(i))
     End If
   Next
   txt.Text = sb.ToString
   txt.SetSelection(txt.Text.Length, txt.Text.Length)
End Sub
Sub iptxt_Action
	If iptxt.Text <> "" Then nameposttxt.RequestFocus
End Sub
Sub iptxt_TextChanged (Old As String, New As String)
Dim sb As StringBuilder
Dim txt As TextField
   txt = Sender	
   sb.Initialize
   For i = 0 To New.Length - 1
     If "0123456789.".IndexOf(New.CharAt(i)) > -1 Then
       sb.Append(New.CharAt(i))
     End If
   Next
   txt.Text = sb.ToString
   txt.SetSelection(txt.Text.Length, txt.Text.Length)
End Sub
Sub nameposttxt_Action
	If nameposttxt.Text <> "" Then inseriscibt_Action 'InsertPost
End Sub
Sub nameposttxt_TextChanged (Old As String, New As String)
	
End Sub
#Region TABELLA POSTAZIONI
Sub InitTable
	File.MakeDir(File.DirApp, "Archivi")
	If File.Exists(File.DirApp, "/Archivi/archivio.db") = False Then
		Dim m As Map
		m.Initialize
		m.Put("Id", DBUtils.DB_INTEGER)
		m.Put("N_Postazione", DBUtils.DB_INTEGER)
		m.Put("Ip", DBUtils.DB_TEXT)
		m.Put("Nome_Postazione", DBUtils.DB_TEXT)
		SQL1.InitializeSQLite(File.DirApp, "Archivi/archivio.db", True)
		DBUtils.CreateTable(SQL1, "Postazioni", m, "Id")
	Else
		SQL1.InitializeSQLite(File.DirApp, "Archivi/archivio.db", True)
	End If
End Sub
Sub InsertPost
Dim mp, mpres As Map
Dim lista As List
	Try
		mp.Initialize
		mpres.Initialize
		mpres.Clear
		lista.Initialize
		mp.Put("Id", Null)
		mp.Put("N_Postazione", nposttxt.Text)
		mp.Put("Ip", iptxt.Text)
		mp.Put("Nome_Postazione", nameposttxt.Text)
		lista.Add(mp)
		mpres = DBUtils.ExecuteMap(SQL1, "SELECT * FROM Postazioni WHERE N_Postazione = " & nposttxt.Text, Null)
		If mpres.IsInitialized = False Then
			DBUtils.InsertMaps(SQL1, "Postazioni", lista)
			RicaricaDB
		Else
			msg.DialogType = "Error"
			msg.Show("Postazione già presente!", "Errore")
			nposttxt.Text = "": nposttxt.RequestFocus
			Return
		End If
		nameposttxt.Text = "": iptxt.Text = "": nposttxt.Text = "": nposttxt.RequestFocus
	Catch As Exception
		msg.DialogType = "Error"
		msg.Show("Errore inserimento in archivio!", "Errore")
	End Try
End Sub
Sub SetColWidth(db As Int)
	Select db
		Case 1
			tablearcpost.SetColumnVisible(0, False)
			tablearcpost.SetColumnWidth(1, 100)
			tablearcpost.SetColumnWidth(2, 120)
			tablearcpost.SetColumnWidth(3, tablearcpost.PrefWidth)
	End Select
End Sub
Sub RicaricaDB
	If SQL1.IsInitialized Then SQL1.Close
	SQL1.InitializeSQLite(File.DirApp, "Archivi/archivio.db", True)
	DBUtils.ExecuteTableView(SQL1, "SELECT * FROM Postazioni", Null, 0, tablearcpost)
	SetColWidth(1)
End Sub
#End Region
Sub inseriscibt_Action
	If nposttxt.Text = "" OR iptxt.Text = "" OR nameposttxt.Text = "" Then
		msg.DialogType = "INFO"
		msg.Show("Vi sono alcuni campi vuoti!", "Info")
		Return
	Else
		InsertPost
	End If
End Sub